/*
**********************************************************************
*                        License Notice
*
* QBuildParameters.java is part of the Quincala Software Project, which is
* aimed at playing, viewing, studying, communicating and publishing
* games; primarily the Quincala games, but in time any game that fits.
*
* (C) Copyright 2010 Ulf Aberg (Åberg) and AB Games Ltd. All Rights
* Reserved.
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
* Here is also a copy of the gpl licence version 3 in html format,
* called "gpl-3.0-standalone.html" in the com.quincala.core/docs folder.
*
* This licence does not provide any license or right to use any
* trademark owned by Ulf Aberg (Åberg) or AB Games Ltd in any form or
* media. QUINCALA is a registered trademark owned by Ulf Aberg (Åberg).
*
* The design of the (classic) Quincala board is a Registered Design,
* also owned by Ulf Aberg (Åberg).
*
* Contact Ulf on ulf@quincala.com
*
**********************************************************************
*/


package com.quincala.core;

public final class QBuildParameters {

	/*
	 * a class to keep build parameters
	 * enabling the same code to be run
	 * in various environments
	 */



	public static final boolean loadTestString = false;//still buggy but works ...
	//testQSFString must be clean!
	public static final String testQString = "~/QSF_char_test.html";
		//;"Quincala;KM;96a6a6696a6axa688776a8877878687998887;0.2";

	public static final boolean tournamentEdition = false;
	public static final String tournamentDateString = "2010-09-17";

	public static final boolean useJNLPServices = false;

	public static final boolean browserTest = false;

	public static final String softwareVersion = "0.9 F2";
	public static final int softwareBuildInt = 8;

//	public static final boolean isAppletViewer = false;
	public static final boolean maySaveToDisk = false;
	//maybe not here; can be read at runtime?
	//false means Viewer app/true means Labs app

	public static final boolean sealOnFinish = false;
	//probably keep false, or even hard code after testing

	public static final boolean loadMaximized = false;
	public static final boolean doConstruction = false;
	//redo system.

	public static final boolean leaveBottomBarArrowSpace = false;
	//only for linux with bottom bar arrow ...

	public static final boolean maximus = false;//for UNR on netbooks



}
